<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">

    <title>Deploying Web Applications: Reproducibility & Isolation</title>

    <meta name="description" content="">
    <meta name="author" content="John Kristensen">

    <link rel="stylesheet" href="css/reveal.css">
    <link rel="stylesheet" href="css/theme/black.css">
    <!-- https://github.com/rfk/playitagainsam-js/ -->
    <link rel="stylesheet" href="lib/playitagainsam-js/playitagainsam.css">
    <!-- Code syntax highlighting -->
    <link rel="stylesheet" href="lib/css/zenburn.css">
    <style>
      .reveal section img {
        border: none;
      }
    </style>
  </head>
  <body>
    <div class="reveal">
      <div class="slides">
        <section data-markdown>
          ## Deploying Web Applications
          ### Reproducibility & Isolation

          ----

          John Kristensen
        </section>

        <section>
          <img src="images/environments_1.png" />
        </section>
        <section>
          <img src="images/environments_2.png" />
        </section>
        <section>
          <img src="images/environments_3.png" />
        </section>
        <section>
          <img src="images/environments_4.png" />
        </section>
        <section>
          <img src="images/environments_5.png" />
        </section>

        <section>
          <h1>Reproducibility</h1>
          <p>ensure the consistency of application environments at deploy
          time</p>
        </section>

        <section data-markdown>
          ## Deploying a web application
          * retrieve application
          * install application dependencies
          * configure application
          * initialise application
          * start the application
        </section>

        <section>
          <h2>Retrieve application</h2>
          <pre><code class="hljs nohighlight" data-trim>
$ tar -zxvf taslug-webapp-1.2.3.tar.gz
          </code></pre>

          <pre><code class="hljs nohighlight" data-trim>
$ sudo apt-get install taslug-webapp-1.2.3.deb
          </code></pre>

          <pre><code class="hljs nohighlight" data-trim>
$ git clone --branch=v1.2.3 http://code.repository.com/taslug.git

$ git fetch origin && git merge --ff-only origin v1.2.3
          </code></pre>
        </section>

        <section>
          <h2>Install application dependencies</h2>
          <pre><code class="hljs nohighlight" data-trim>
$ sudo apt-get install python-flask gunicorn
          </code></pre>

          <pre><code class="hljs nohighlight" data-trim>
$ pip install flask gunicorn
          </code></pre>
        </section>

        <section>
          <h2>Install application dependencies</h2>
          <p align=left>requirements.txt</p>
          <pre><code class="hljs nohighlight" data-trim>
Flask==0.10.1
gunicorn==19.3.0

          </code></pre>

          <p align=left>install dependencies:</p>
          <pre><code class="hljs nohighlight" data-trim>
$ pip install -r requirements.txt
          </code></pre>
        </section>

        <section>
          <h2>Configure application</h2>
          <p align="left">Web interface configuration:</p>
          <p>http://webapp.taslug.org.au/install.php</p>

          <p align="left">Edit config file:</p>
          <pre><code class="hljs nohighlight" data-trim>
$ cp config.php-dist config.php
$ vi config.php
          </code></pre>
        </section>

        <section>
          <h2>Configure application</h2>

          <pre><code class="hljs python" data-trim>
$ export DB_HOSTNAME=taslugdb1
$ export DB_PASSWORD=sekrit!
          </code></pre>

          <p align="left">config.py</p>
          <pre><code class="hljs python" data-trim>
from os import environ

def get_env_setting(setting):
    try:
        return environ[setting]
    except KeyError:
        error_msg = "Set the %s env variable" % setting
        raise ImproperlyConfigured(error_msg)
          </code></pre>
          <p>...</p>
          <pre><code class="hljs python" data-trim>
DB_HOSTNAME = get_env_setting('DB_HOSTNAME')
DB_USERNAME = 'taslug_webapp'
DB_PASSWORD = get_env_var('DB_PASSWORD')
DB_PORT = 80
          </code></pre>
        </section>

        <section>
          <h2>Initialise application</h2>
          <p align="left">Web interface configuration:</p>
          <p>http://webapp.taslug.org.au/install.php</p>
          <p align="left">Login to update:</p>
          <p>http://webapp.taslug.org.au/admin.php</p>
        </section>

        <section data-markdown>
          ## Run Application
          apache + mod_php/mod_python
        </section>

        <section>
          <h2>Run Application</h2>

          <p>apache + mod_proxy + application server</p>

          <img src="images/apache_app_server.png" />
        </section>

        <section data-markdown>
          ## Deploying a web application
          * retrieve application
          * install application dependencies
          * configure application
          * initialise application
          * start the application
        </section>

        <section data-markdown>
          # Immutability
          ensure no changes to the application's environment occur during runtime
        </section>

        <section>
          <h2>Resource Isolation</h2>
          <img src="images/resource_isolation.png" />
        </section>

        <section data-markdown>
          ## The Twelve-Factor App
          http://12factor.net/
        </section>

        <section>
          <img src="images/fine_in_dev_ops_problem_now.jpg" />
        </section>

        <section>
          <img src="images/multiple_apps_system.png" width="70%" />
        </section>
        <section>
          <img src="images/multiple_apps_virtualenv.png" width="70%" />
        </section>

        <section>
          <h4>virtualenv</h4>
          <pre><code class="hljs nohighlight" data-trim>
$ pip freeze
BeautifulSoup==3.2.1
CherryPy==3.5.0
Jinja2==2.8
Markdown==2.6.5
MarkupSafe==0.23
Pillow==3.1.1
...
supervisor==3.2.0
tornado==4.2.1
uTidylib==0.2
vboxapi==1.0
virtualenv==1.11.6
wsgiref==0.1.2
          </code></pre>
        </section>

        <section>
          <h4>virtualenv</h4>
          <p align="left">requirements.txt</p>
          <pre><code class="hljs nohighlight" data-trim>
Flask==0.10.1
gunicorn==19.4.5
          </code></pre>

          <p align="left">Install dependencies in virtualenv:</p>
          <pre><code class="hljs nohighlight" data-trim>
$ cd taslug
$ virtualenv venv
$ source venv/bin/activate

(venv)$ pip install -r requirements.txt
(venv)$ pip freeze
Flask==0.10.1
Jinja2==2.8
MarkupSafe==0.23
Werkzeug==0.11.4
argparse==1.2.1
gunicorn==19.4.5
itsdangerous==0.24
wsgiref==0.1.2
          </code></pre>
        </section>

        <section>
          <h4>Run application as root</h4>
          <pre><code class="hljs nohighlight" data-trim>
root@stark:/var/www/taslug# gunicorn -b 0.0.0.0:80 webapp:app
          </code></pre>

          <p align="left" class="fragment" data-fragment-index="1">code:</p>
          <pre class="fragment" data-fragment-index="1"><code class="hljs python" data-trim>
import yaml
data = yaml.load(request.data)
          </code></pre>

          <p align="left" class="fragment" data-fragment-index="1">yaml request:</p>
          <pre class="fragment" data-fragment-index="1"><code class="hljs yaml" style="font-size: 90%" data-trim>
first_name: John
last_name: Kristensen
exploit:
  !!python/object/apply:subprocess.check_output [['rm', '-rf', '/']]
          </code></pre>

          <br />
          <hr class="fragment" data-fragment-index="1" />

          <small class="fragment" data-fragment-index="1">
            <a href="https://www.youtube.com/watch?v=LrW-HSHP0ws">
              Tom Eastman - Serialization formats are not toys
            </a> (PyConAU 2014)
          </small>
        </section>

        <section>
          <h4>Run application as taslug user</h4>
          <pre><code class="hljs nohighlight" data-trim>
root@stark:/var/www/taslug# adduser taslug
root@stark:/var/www/taslug# su - taslug

taslug@stark:/var/www/taslug$ gunicorn -b 0.0.0.0:80 webapp:app
          </code></pre>

          <p align="left" class="fragment" data-fragment-index="1">yaml request:</p>
          <pre class="fragment" data-fragment-index="1"><code class="hljs yaml" style="font-size: 90%" data-trim>
cat_passwd:
  !!python/object/apply:subprocess.check_output [['cat', '/etc/passwd']]
list_packages:
  !!python/object/apply:subprocess.check_output [['dpkg-query', '-l']]
processes:
  !!python/object/apply:subprocess.check_output [['ps', 'aux']]
          </code></pre>
        </section>

        <section>
          <h4>Run application in a chroot</h4>
          <img src="images/chroot_root_tree.png" width="60%" />
        </section>
        <section>
          <h4>Run application in a chroot</h4>
          <img src="images/chroot_structure.png" width="60%" />
        </section>

        <section>
          <h4>Run application in a chroot</h4>
          <p align="left">Create chroot directory structure:</p>
          <p><i>&lt;insert lots of work to create a directory structure&gt;</i></p>
          <p align="left">Enter chroot environment:</p>
          <pre><code class="hljs nohighlight" style="font-size: 95%" data-trim>
root@stark:~# chroot --userspec=taslug /home/taslug/chroot/ /bin/bash

taslug@stark:/var/www/taslug$ gunicorn -b 0.0.0.0:80 webapp:app
          </code></pre>
        </section>

        <section>
          <h4>One virtual machine per application<h4>

          <img src="images/one_app_per_vm.png" />
        </section>

        <section>
          <img src="images/burnt_data_centre_cropped.jpeg" />
        </section>
        <section>
          <img src="images/burnt_data_centre_cropped_paas_logos.jpeg" />
        </section>

        <section>
          <img src="images/docker_logo.jpg" width="60%" />
          <p class="fragment">
            or<br />
            LXC &mdash; rkt &mdash; systemd-spawn
          </p>
        </section>

        <section data-markdown>
          ## Linux containers
          * chroot
          * control groups (cgroups)
            * CPU, memory, network, disk I/O
          * namespace isolation
            * PIDs, network, UTS, users, mounts, IPC
        </section>

        <section data-markdown>
          ### _Demo: pull/run docker container_
        </section>

        <section>
          <h4>Example Application</h4>
          <p align="left">webapp.py</p>
          <pre><code class="hljs python" data-trim>
import socket
import config
from flask import Flask, request

app = Flask(__name__)

@app.route('/')
def main():
    return """\
Hello TasLUG!

From: {}
Listening on port: {}
The secret is: {}
""".format(socket.gethostname(), request.environ['SERVER_PORT'],
           config.SECRET)
          </code></pre>
        </section>

        <section>
          <h4>Example Application</h4>
          <p align="left">config.py</p>
          <pre><code class="hljs python" data-trim>
from os import environ

def get_env_settings(setting):
    try:
        return environ[setting]
    except KeyError:
        error_msg = "Set the %s env variable" % setting
        raise EnvironmentError(error_msg)

SECRET = get_env_settings('WEBAPP_SECRET')
          </code></pre>

          <p align="left">requirements.txt</p>
          <pre><code class="hljs" data-trim>
Flask==0.10.1
gunicorn==19.3.0
          </code></pre>
        </section>

        <section data-markdown>
          ### _Demo: Local Webapp_
        </section>

        <section>
          <h4>Building a docker container</h4>
          <p align="left">Dockerfile</p>
          <pre><code class="hljs dockerfile" data-trim>
FROM debian:jessie

RUN apt-get update && apt-get install -y python python-virtualenv

RUN mkdir -p /var/www/taslug
ADD webapp.py config.py requirements.txt /var/www/taslug/

WORKDIR /var/www/taslug
RUN virtualenv venv
RUN venv/bin/pip install -r requirements.txt

CMD /var/www/taslug/venv/bin/gunicorn -b 0.0.0.0:80 webapp:app
          </code></pre>
        </section>

        <section data-markdown>
          ### _Demo: Docker Webapp_
        </section>

        <section>
          <h1>Questions?</h1>
          <ul>
            <li>Email: john@jerrykan.com</li>
            <li>Twitter: @jerrykan</li>
            <li>GNUSocial: jerrykan@taslug.org.au</li>
          </ul>
          <hr />
          <p>
            Support the Software Freedom Conservancy<br />
            <a href="https://sfconservancy.org/supporter/">
              https://sfconservancy.org/supporter/
            </a>
          </p>
          <img src="images/software_freedom_conservancy.png" />
        </section>
      </div>
    </div>

    <script src="lib/js/head.min.js"></script>
    <script src="js/reveal.js"></script>
    <script>
      Reveal.initialize({
        transition: 'none',
        slideNumber: true,

        dependencies: [
          // Interpret Markdown in <section> elements
          { src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
          { src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },

          // Code highlighting
          { src: 'plugin/highlight/highlight.js', async: true, callback: function() { hljs.initHighlightingOnLoad(); } },
          // Speaker notes
          { src: 'plugin/notes/notes.js', async: true }
        ]
      })
    </script>
  </body>
</html>

